Ext.ux.GMapPanel = Ext.extend(Ext.Panel, {
    gmap:null,
    lastPoint : null,
    lastMark : null,
    marker : null,
    browserSupportFlag : new Boolean(),
    initialLocation: null,
    geocoder:null,
    zoom:0,
    markersArray:new Array(),
    setZoom:function(zoom){
        this.zoom = zoom;
    },
    getZoom:function(){
      return this.zoom;  
    },
    placeMarker : function (location,description) {
    //console.log(lastMark)
        /*if(this.lastMark != null){
            this.lastMark.setVisible(false);
        }*/
        this.marker = new google.maps.Marker({
            position: location, 
            map: this.gmap,
            title:description
        });
        //this.lastMark = this.marker;
        this.gmap.setCenter(location);
        
        //var mark = this.marker;
        var infoWindow = new google.maps.InfoWindow();  
        var content = "Longitud: " + description;  
        infoWindow.setContent(content);    
        infoWindow.open(this.gmap, this.marker);
        
        
        this.markersArray.push(this.marker);
        google.maps.event.addListener(this.marker, 'click', function(event) {  
            infoWindow.open(this.gmap, this.marker);  
        }); 
    },
    // Removes the overlays from the map, but keeps them in the array
    clearOverlays:function() {
      if (this.markersArray.length != 0) {
        for (i in this.markersArray) {
         this.markersArray[i].setMap(null);
        }
      }
    },
    // Shows any overlays currently in the array
    showOverlays:function() {
      if (this.markersArray.length != 0) {
        for (i in this.markersArray) {
          this.markersArray[i].setMap(this.gmap);
        }
      }
    },
    // Deletes all markers in the array by removing references to them
    deleteOverlays:function(d) {
        console.log(this.markersArray);
      if (this.markersArray && d=="b") {
        for (i in this.markersArray) {
          this.markersArray[i].setMap(null);
        }
        this.markersArray.length = 0;
      }
    },
    geoSearchOne:function(geo){
        this.geocoder = new google.maps.Geocoder();
        this.processGeocoding(geo);
    },
    geoSearchSeveral:function(geo){
        this.geocoder = new google.maps.Geocoder();
        this.processGeocoding(geo);
    },
    processGeocoding:function(location){//,callback   
        // Propiedades de la georreferenciación  
        var thisPanel = this;
        var request = {  
            address: location  
        }  
        // Invocación a la georreferenciación (proceso asíncrono)  
        this.geocoder.geocode(request, function(results, status) {  
            /* 
             * OK 
             * ZERO_RESULTS 
             * OVER_QUERY_LIMIT 
             * REQUEST_DENIED 
             * INVALID_REQUEST 
             */  
            // Notifica al usuario el resultado obtenido  
            //console.log("Respuesta obtenida: " + status);  
            // En caso de terminarse exitosamente el proyecto ...  
            if(status == google.maps.GeocoderStatus.OK)  
            {  
                // Invoca la función de callback  
                //thisPanel.addMarkers(results);  //callback 
                //console.log(results,thisPanel);
                thisPanel.addMarkers(results);
                // Retorna los resultados obtenidos  
                return results;  
            }  
            // En caso de error retorna el estado  
            return status;  
        });  
    },
    addMarkers:function(geocodes)  
    {  
        for(i=0; i<geocodes.length; i++)  
        {  
            // Centra el mapa en la nueva ubicación  
            this.gmap.setCenter(geocodes[i].geometry.location);  
            // Valores iniciales del marcador  
            var marker = new google.maps.Marker({  
                map: this.gmap,  
                title: geocodes[i].formatted_address  
            });  
            // Establece la ubicación del marcador  
            marker.setPosition(geocodes[i].geometry.location);  
            // Establece el contenido de la ventana de información  
            var infoWindow = new google.maps.InfoWindow();  
            var content = "Ubicación: " + geocodes[i].formatted_address + "<br />" +  
                      "Tipo: " + geocodes[i].types + "<br />" +  
                      "Latitud: " + geocodes[i].geometry.location.lat() + "<br />" +  
                      "Longitud: " + geocodes[i].geometry.location.lng();  
            infoWindow.setContent(content);    
            infoWindow.open(this.gmap, marker);
            // Asocia el evento de clic sobre el marcador con el despliegue  
            // de la ventana de información  
            //this.setLastPoint(event.latLng);
            this.setLastMark(marker);
            this.marker = marker;
            this.markersArray.push(this.marker);
            google.maps.event.addListener(marker, 'click', function(event) {  
                infoWindow.open(this.gmap, marker);  
            });  
        }  
        this.getMap().setZoom(this.getZoom());
    },
    setCenter:function(lat,lon){
        var latlng = new google.maps.LatLng(10.583587,-71.639703);
        this.gmap.setCenter(latlng);        
    },
    setLastPoint:function(point){
        this.lastPoint = point;
    },
    setLastMark:function(mark){
        this.lastMark = mark;
    },
    setMarker:function(marker){
        this.marker = marker;
    },
    getLastPoint:function(){
        return this.lastPoint;
    },
    getLastMark:function(){
        return this.lastMark;
    },
    getMarker:function(){
        return this.marker;
    },
    getInitialLocation:function(){
        return this.initialLocation;
    },
    initComponent : function(){
        
        var defConfig = {
            plain: true,
            zoomLevel: 3,
            yaw: 180,
            pitch: 0,
            zoom: 0,
            gmapType: 'map',
            border: false/*,
            width:500,
            height:500*/
        };
        
        Ext.applyIf(this,defConfig);
        
        Ext.ux.GMapPanel.superclass.initComponent.call(this);        

    },
    afterRender : function(){
        
        var wh = this.ownerCt.getSize();   
        var thisPanel = null;
        var locationHTML5 = null;
        
        Ext.applyIf(this, wh);
        //this.initialLocation = new google.maps.LatLng(10.583587,-71.639703);//(8.000, -70.644);
        
        
        Ext.ux.GMapPanel.superclass.afterRender.call(this); 
        if (this.gmapType === 'map'){
            var myOptions = {
                zoom: 6,//16,//5,
                //center: locationHTML5,
                mapTypeId: google.maps.MapTypeId.ROADMAP //HYBRID //ROADMAP
            };
            this.gmap = new google.maps.Map(this.body.dom,myOptions);//this.body.dom
            
            
            if(navigator.geolocation) {
                this.browserSupportFlag = true;
                var bodyPanel = this.body.dom;
                thisPanel = this;
                navigator.geolocation.getCurrentPosition(function(position) {
                    locationHTML5 = new google.maps.LatLng(position.coords.latitude,position.coords.longitude);
                    thisPanel.setCenter(locationHTML5);
                }, function() {
                  this.handleNoGeolocation(this.browserSupportFlag);
                });
            }
        }
        
        /*GEvent.bind(this.gmap, 'load', this, function(){
            //this.onMapReady();
        });*/

    },
    onResize : function(w, h){

        /*if (typeof this.getMap() == 'object') {
            this.gmap.checkResize();
        }*/
        
        Ext.ux.GMapPanel.superclass.onResize.call(this, w, h);

    },
    setSize : function(width, height, animate){
        
        /*if (typeof this.getMap() == 'object') {
            this.gmap.checkResize();
        }*/
        
        Ext.ux.GMapPanel.superclass.setSize.call(this, width, height, animate);
        
    },
    getMap : function(){
        
        return this.gmap;
        
    },
    handleNoGeolocation:function(errorFlag) {
        if (errorFlag == true) {
          alert("El servicio de geolocalizaci&oacute;n fall&oacute;.");
          this.initialLocation = newyork;
        }
        this.gmap.setCenter(this.initialLocation);
    }
 
});

///Ext.reg('gmappanel', Ext.ux.GMapPanel);